int f(int n) {
	if (n == 0) {
		return 1;
	}
	return n * f(n - 1);
}

f(n) връща n!

База:
f(0) връща 1 и 0! = 1

Допускаме, че f(m) връща m!, за всяко m < n

f(n) връща n!, за n > 0

връщаме n * f(n - 1), но n - 1<n => f(n - 1) връща (n - 1)!
=> връщаме n * (n - 1)! = n!


int slowExp(int x, int n) {
	if (n == 0) {
		return 1;
	}
	return x * slowExp(x, n - 1);
}



int fastExp(int x, int n) {
	if (n == 0) {
		return 1;
	}

	if (n % 2 == 0) {
		return fastExp(x * x, n / 2)
	} else {
		return x * fastExp(x * x, (n - 1) / 2)
	}
}

fastExp(x, n) връща x^n

База:
n = 0, fastExp(x, 0) връща 1 и x^0 e 1, вярно

Допускаме, че fastExp(x, m) връща x^m, за всяко m < n

fastExp(x, n) връща x^n ??? n > 0


Ако n e четно, тогава
ред 36-ти ще върне fastExp(x * x, n / 2), по предположението понеже n / 2 < n
fastExp(x * x, n / 2)  връща (x*x)^n/2
но (x*x)^(n/2) = x^(2*n/2) = x^n


Ако n e нечетно, тогава
ред 38-ми ще върне x * fastExp(x * x, (n - 1) / 2), по предположението понеже (n - 1) / 2 < n
fastExp(x * x, (n - 1) / 2)  връща (x*x)^(n-1)/2

но x * (x*x)^(n-1)/2 = x * x^(2*(n-1)/2)= x*x^(n-1)= x^n


=> 
fastExp(x, n) връща x^n за всяко цяло n>=0










